//
//  MyFilter.m
//  SoundGenThru
//
//  Created by Justin Bakse on Fri Feb 20 2004.
//  Copyright (c) 2004 __MyCompanyName__. All rights reserved.
//

#import "MyFilter.h"


@implementation MyFilter

/* init
 this function is called once when the instance is created, this is a good place to initialize variables

*/

-init
{
    [super init];
    if (self){
        int n;
        bLength = 44100;
        for (n = 0; n < bLength; n++){
            buffer[n] = 0;
        }
        
        
        readPos = 0;
        writePos = 0;
        delay = 44100/2;
        
        
        
        lfo1.shape = kSineWave;
        lfo1.freq = 10;
        lfo1.amplitude = 90;
        lfo1.offset = 100;
        lfo1.active = 1;
        lfo1.pos = 0;
        
        
       
    }
    return self;
}

/* init
this function is called everytime the audio port needs a new packet of info to play.
you will recieve the following arguments:
1 an array of floats representing INPUT audio
2 an array of floats representing OUTPUT audio
3 how many samples are in each array
4 a number indicating which channel the information is for ( 0 - Left, 1 - Right)
*/


- (void)filterInput:(const float*)input
             Output:(float*)output
        SampleCount:(UInt32)sampleCount
            Channel:(UInt32)channel
{
    int n;


        
    if (channel == 0) { //left channel
        for (n = 0; n < sampleCount; n++){
            float lfo1BaseValue;
            float lfo1Period;
            // ********************************************
            //   LFO1 (controls the amount of the delay)
            // ********************************************
            
            //these lines move occilator from 0 - 1, 0 - 1, 0 - 1 ....
            lfo1Period = 44100 / lfo1.freq;  
            lfo1.pos += 1/lfo1Period; if (lfo1.pos >= 1) lfo1.pos -= 1;
            
            //convert the occilator to the correct shape
            if (lfo1.shape == kSawWave) lfo1BaseValue = ( lfo1.pos * 2 - 1) * lfo1.amplitude;
            if (lfo1.shape == kSquareWave) lfo1BaseValue = (( lfo1.pos < .5) * 2 - 1) * lfo1.amplitude;
            if (lfo1.shape == kSineWave) lfo1BaseValue = sin( lfo1.pos* 6.283) * lfo1.amplitude;
            
            //tie the occilator to the frequency value of the hfo
            if (lfo1.active) delay= lfo1BaseValue + lfo1.offset;
          //  printf("delay:%d\n", delay);
            
            
            
            
            
            // ********************************************
            //   Delay buffer (controls the amount of the delay)
            // ********************************************
            
            buffer[writePos] = input[n];
            readPos = writePos - delay;
            if (readPos < 0) readPos += bLength;
            writePos++; if (writePos >= bLength) writePos -= bLength;
            
            output[n] =  (input[n] + buffer[readPos])/2.0;
        }
    }else{ //right channel
        for (n = 0; n < sampleCount; n++){
          
        }
    }
    
}

- (IBAction)setRate:(id)sender{
    lfo1.freq = [sender floatValue];
}
- (IBAction)setDepth:(id)sender{
    lfo1.amplitude = [sender floatValue];
    lfo1.offset =   lfo1.amplitude + 1;

}



@end
