//
//  MyRingBuffer.h
//  SoundGenThru
//
//  Created by Justin Bakse on Thu Feb 19 2004.
//  This is very nearly a direct port of the AudioRingBuffer C++ class from Apple's AudioThru example.
//

#import <Foundation/Foundation.h>


@interface MyRingBuffer : NSObject {
    @protected
    UInt32		mBytesPerFrame; 
    UInt32		mCapacityFrames; //size of the buffer in Frames
    UInt32		mCapacityBytes;  //size of the buffer in bytes (frames * chans * depth)
    Byte *		mBuffer;
    UInt32		mStartOffset;    //offset in bytes to location of 
    SInt64		mStartFrame;     //time of oldest sample in buffer
    SInt64		mEndFrame;       //time of newest sample in buffer
}

-(void)AllocateBytes:(int)bytesPerFrame 
           forFrames:(int) capacityFrames;

-(void)Clear;

-(Boolean)storeData:(const Byte *) data
          Frames:(UInt32) frames
            Time:(long) frameNumber;

-(double)fetchData:(Byte *) data
            Frames:(UInt32) frames
              Time:(long) frameNumber;

-(UInt32)FrameOffset:(SInt64) frameNumber; 
@end
